%MAIN PROGRAM
% Galo Nuno (2016)
clear all; clc;

%PARAMETERS
r_guess       = 0.03;                       % world interest rate
gamma         = 2;                          % CRRA utility with parameter s
rho           = 0.0301;                     % discount rate
la1           = 0.5;                        % transition prob
la2           = 1/3;
z1            = 0.93;                       % labor productivity
z2            = 1+ la2/la1 *(1- z1);
amin          = -2;                         % borrowing constraint
amax          = 10;                         % max value of assets
                       
I        = 1000;                            % numer of points
maxit    = 100;                             % max number of iterations
crit     = 10^(-6);                         % convergence ctrit 
Delta    = 1000;                            % Delta in HJB

parameters.gamma  = gamma;
parameters.rho    = rho;
parameters.z1     = z1;
parameters.z2     = z2;
parameters.la1    = la1;
parameters.la2    = la2;
parameters.I      = I;
parameters.amin   = amin;
parameters.amax   = amax;
parameters.maxit  = maxit;
parameters.crit   = crit;
parameters.Delta  = Delta;

%---------------------------------------------------
% STEADY-STATE
r = fzero(@(r) equilibrium(parameters,r), r_guess);
results      = HJB_stationary(parameters,r);
distribution = KFE_stationary(parameters,results);
 
%OPTIONS
Moments
plotting